Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkSynchronizedTemplates3D Class Reference

`#include <vtkSynchronizedTemplates3D.h>`

Inheritance diagram for vtkSynchronizedTemplates3D:

[legend]
Collaboration diagram for vtkSynchronizedTemplates3D:

[legend]
List of all members.

## Detailed Description

generate isosurface from structured points

Date:
  2003/01/09 19:21:05

Revision:
  1.31

vtkSynchronizedTemplates3D is a 3D implementation of the synchronized template algorithm. Note that vtkContourFilter will automatically use this class when appropriate if vtk was built with patents.

Warning:
  This filter is specialized to 3D images (aka volumes).

See also:
  vtkContourFilter vtkSynchronizedTemplates2D

Created by:
  - Law, Charles

CVS contributions (if > 5%):
  - Law, Charles (54%)
  - Geveci, Berk (36%)

CVS logs (CVSweb):
  - .`h` (`/Patented/vtkSynchronizedTemplates3D.h)`
  - .`cxx` (`/Patented/vtkSynchronizedTemplates3D.cxx)`

Tests:
  vtkSynchronizedTemplates3D (Tests)

Definition at line 69 of file vtkSynchronizedTemplates3D.h.

## Public Types
typedef vtkPolyDataSource | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
unsigned long int | GetMTime ()
void | SetValue (int i, float value)
float | GetValue (int i)
float * | GetValues ()
void | SetInput (vtkImageData *input)
vtkImageData * | GetInput ()
virtual void | SetComputeNormals (int)
virtual int | GetComputeNormals ()
virtual void | ComputeNormalsOn ()
virtual void | ComputeNormalsOff ()
virtual void | SetComputeGradients (int)
virtual int | GetComputeGradients ()
virtual void | ComputeGradientsOn ()
virtual void | ComputeGradientsOff ()
virtual void | SetComputeScalars (int)
virtual int | GetComputeScalars ()
virtual void | ComputeScalarsOn ()
virtual void | ComputeScalarsOff ()
void | GetValues (float *contourValues)
void | SetNumberOfContours (int number)
int | GetNumberOfContours ()
void | GenerateValues (int numContours, float range[2])
void | GenerateValues (int numContours, float rangeStart, float rangeEnd)
int * | GetExecuteExtent ()
void | ThreadedExecute (vtkImageData *data, int *exExt, int threadId)
virtual void | SetNumberOfThreads (int)
virtual int | GetNumberOfThreads ()
void | SetInputMemoryLimit (unsigned long limit)
unsigned long | GetInputMemoryLimit ()
## Static Public Methods
vtkSynchronizedTemplates3D * | New ()
int | IsTypeOf (const char *type)
vtkSynchronizedTemplates3D * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkSynchronizedTemplates3D ()
| ~vtkSynchronizedTemplates3D ()
void | Execute ()
void | ExecuteInformation ()
void | ComputeInputUpdateExtents (vtkDataObject *output)
virtual void | SetInputScalarsSelection (const char *)
virtual char * | GetInputScalarsSelection ()
void | SelectInputScalars (const char *fieldName)
## Protected Attributes
int | ComputeNormals
int | ComputeGradients
int | ComputeScalars
vtkContourValues * | ContourValues
int | ExecuteExtent [6]
int | NumberOfThreads
vtkMultiThreader * | Threader
vtkPolyData * | Threads [VTK_MAX_THREADS]
char * | InputScalarsSelection
## Friends
class VTK_PATENTED_EXPORT | vtkKitwareContourFilter

## Member Typedef Documentation

typedef vtkPolyDataSource vtkSynchronizedTemplates3D::Superclass

| Reimplemented from vtkPolyDataSource. Definition at line 74 of file vtkSynchronizedTemplates3D.h.

## Constructor & Destructor Documentation

vtkSynchronizedTemplates3D::vtkSynchronizedTemplates3D | ( |  | ) | `[protected]`

vtkSynchronizedTemplates3D::~vtkSynchronizedTemplates3D | ( |  | ) | `[protected]`

## Member Function Documentation

vtkSynchronizedTemplates3D* vtkSynchronizedTemplates3D::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkSynchronizedTemplates3D::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkPolyDataSource.

int vtkSynchronizedTemplates3D::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPolyDataSource.

virtual int vtkSynchronizedTemplates3D::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPolyDataSource.

vtkSynchronizedTemplates3D* vtkSynchronizedTemplates3D::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkPolyDataSource.

void vtkSynchronizedTemplates3D::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkPolyDataSource.

void vtkSynchronizedTemplates3D::SetInput | ( | vtkImageData * | input | ) |

| Set/Get the source for the scalar data to contour.

vtkImageData* vtkSynchronizedTemplates3D::GetInput | ( |  | ) |

| Set/Get the source for the scalar data to contour.

unsigned long int vtkSynchronizedTemplates3D::GetMTime | ( |  | ) | `[virtual]`

| Because we delegate to vtkContourValues Reimplemented from vtkObject.

virtual void vtkSynchronizedTemplates3D::SetComputeNormals | ( | int |  | ) | `[virtual]`

| Set/Get the computation of normals. Normal computation is fairly expensive in both time and storage. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual int vtkSynchronizedTemplates3D::GetComputeNormals | ( |  | ) | `[virtual]`

| Set/Get the computation of normals. Normal computation is fairly expensive in both time and storage. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkSynchronizedTemplates3D::ComputeNormalsOn | ( |  | ) | `[virtual]`

| Set/Get the computation of normals. Normal computation is fairly expensive in both time and storage. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkSynchronizedTemplates3D::ComputeNormalsOff | ( |  | ) | `[virtual]`

| Set/Get the computation of normals. Normal computation is fairly expensive in both time and storage. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkSynchronizedTemplates3D::SetComputeGradients | ( | int |  | ) | `[virtual]`

| Set/Get the computation of gradients. Gradient computation is fairly expensive in both time and storage. Note that if ComputeNormals is on, gradients will have to be calculated, but will not be stored in the output dataset. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual int vtkSynchronizedTemplates3D::GetComputeGradients | ( |  | ) | `[virtual]`

| Set/Get the computation of gradients. Gradient computation is fairly expensive in both time and storage. Note that if ComputeNormals is on, gradients will have to be calculated, but will not be stored in the output dataset. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkSynchronizedTemplates3D::ComputeGradientsOn | ( |  | ) | `[virtual]`

| Set/Get the computation of gradients. Gradient computation is fairly expensive in both time and storage. Note that if ComputeNormals is on, gradients will have to be calculated, but will not be stored in the output dataset. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkSynchronizedTemplates3D::ComputeGradientsOff | ( |  | ) | `[virtual]`

| Set/Get the computation of gradients. Gradient computation is fairly expensive in both time and storage. Note that if ComputeNormals is on, gradients will have to be calculated, but will not be stored in the output dataset. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkSynchronizedTemplates3D::SetComputeScalars | ( | int |  | ) | `[virtual]`

| Set/Get the computation of scalars.

virtual int vtkSynchronizedTemplates3D::GetComputeScalars | ( |  | ) | `[virtual]`

| Set/Get the computation of scalars.

virtual void vtkSynchronizedTemplates3D::ComputeScalarsOn | ( |  | ) | `[virtual]`

| Set/Get the computation of scalars.

virtual void vtkSynchronizedTemplates3D::ComputeScalarsOff | ( |  | ) | `[virtual]`

| Set/Get the computation of scalars.

void vtkSynchronizedTemplates3D::SetValue | ( | int | i,
|  | float | value
| ) | `[inline]`

| Set a particular contour value at contour number i. The index i ranges between 0<=i<NumberOfContours. Definition at line 117 of file vtkSynchronizedTemplates3D.h.

float vtkSynchronizedTemplates3D::GetValue | ( | int | i | ) | `[inline]`

| Get the ith contour value. Definition at line 120 of file vtkSynchronizedTemplates3D.h.

float* vtkSynchronizedTemplates3D::GetValues | ( |  | ) | `[inline]`

| Get a pointer to an array of contour values. There will be GetNumberOfContours() values in the list. Definition at line 124 of file vtkSynchronizedTemplates3D.h.

void vtkSynchronizedTemplates3D::GetValues | ( | float * | contourValues | ) | `[inline]`

| Fill a supplied list with contour values. There will be GetNumberOfContours() values in the list. Make sure you allocate enough memory to hold the list. Definition at line 130 of file vtkSynchronizedTemplates3D.h.

void vtkSynchronizedTemplates3D::SetNumberOfContours | ( | int | number | ) | `[inline]`

| Set the number of contours to place into the list. You only really need to use this method to reduce list size. The method SetValue() will automatically increase list size as needed. Definition at line 138 of file vtkSynchronizedTemplates3D.h.

int vtkSynchronizedTemplates3D::GetNumberOfContours | ( |  | ) | `[inline]`

| Get the number of contours in the list of contour values. Definition at line 144 of file vtkSynchronizedTemplates3D.h.

void vtkSynchronizedTemplates3D::GenerateValues | ( | int | numContours,
|  | float | range[2]
| ) | `[inline]`

| Generate numContours equally spaced contour values between specified range. Contour values will include min/max range values. Definition at line 151 of file vtkSynchronizedTemplates3D.h.

void vtkSynchronizedTemplates3D::GenerateValues | ( | int | numContours,
|  | float | rangeStart,
|  | float | rangeEnd
| ) | `[inline]`

| Generate numContours equally spaced contour values between specified range. Contour values will include min/max range values. Definition at line 158 of file vtkSynchronizedTemplates3D.h.

int* vtkSynchronizedTemplates3D::GetExecuteExtent | ( |  | ) | `[inline]`

| Needed by templated functions. Definition at line 164 of file vtkSynchronizedTemplates3D.h.

void vtkSynchronizedTemplates3D::ThreadedExecute | ( | vtkImageData * | data,
|  | int * | exExt,
|  | int | threadId
| ) |

| Needed by templated functions.

virtual void vtkSynchronizedTemplates3D::SetNumberOfThreads | ( | int |  | ) | `[virtual]`

| Get/Set the number of threads to create when rendering

virtual int vtkSynchronizedTemplates3D::GetNumberOfThreads | ( |  | ) | `[virtual]`

| Get/Set the number of threads to create when rendering

void vtkSynchronizedTemplates3D::SetInputMemoryLimit | ( | unsigned long | limit | ) |

| Determines the chunk size fro streaming. This filter will act like a collector: ask for many input pieces, but generate one output. Limit is in KBytes

unsigned long vtkSynchronizedTemplates3D::GetInputMemoryLimit | ( |  | ) |

| Determines the chunk size fro streaming. This filter will act like a collector: ask for many input pieces, but generate one output. Limit is in KBytes

virtual char* vtkSynchronizedTemplates3D::GetInputScalarsSelection | ( |  | ) | `[protected, virtual]`

| If you want to contour by an arbitrary array, then set its name here. By default this in NULL and the filter will use the active scalar array.

void vtkSynchronizedTemplates3D::SelectInputScalars | ( | const char * | fieldName | ) | `[inline, protected]`

| If you want to contour by an arbitrary array, then set its name here. By default this in NULL and the filter will use the active scalar array. Definition at line 191 of file vtkSynchronizedTemplates3D.h.

void vtkSynchronizedTemplates3D::Execute | ( |  | ) | `[protected, virtual]`

| This method is the old style execute method Reimplemented from vtkSource.

void vtkSynchronizedTemplates3D::ExecuteInformation | ( |  | ) | `[protected, virtual]`

| Reimplemented from vtkSource.

void vtkSynchronizedTemplates3D::ComputeInputUpdateExtents | ( | vtkDataObject * | output | ) | `[protected, virtual]`

| What is the input update extent that is required to produce the desired output? By default, the whole input is always required but this is overridden in many subclasses. Reimplemented from vtkPolyDataSource.

virtual void vtkSynchronizedTemplates3D::SetInputScalarsSelection | ( | const char * |  | ) | `[protected, virtual]`

## Friends And Related Function Documentation

friend class VTK_PATENTED_EXPORT vtkKitwareContourFilter`[friend]`

| Definition at line 218 of file vtkSynchronizedTemplates3D.h.

## Member Data Documentation

int vtkSynchronizedTemplates3D::ComputeNormals`[protected]`

| Definition at line 196 of file vtkSynchronizedTemplates3D.h.

int vtkSynchronizedTemplates3D::ComputeGradients`[protected]`

| Definition at line 197 of file vtkSynchronizedTemplates3D.h.

int vtkSynchronizedTemplates3D::ComputeScalars`[protected]`

| Definition at line 198 of file vtkSynchronizedTemplates3D.h.

vtkContourValues* vtkSynchronizedTemplates3D::ContourValues`[protected]`

| Definition at line 199 of file vtkSynchronizedTemplates3D.h.

int vtkSynchronizedTemplates3D::ExecuteExtent[6]`[protected]`

| Definition at line 206 of file vtkSynchronizedTemplates3D.h.

int vtkSynchronizedTemplates3D::NumberOfThreads`[protected]`

| Definition at line 208 of file vtkSynchronizedTemplates3D.h.

vtkMultiThreader* vtkSynchronizedTemplates3D::Threader`[protected]`

| Definition at line 209 of file vtkSynchronizedTemplates3D.h.

vtkPolyData* vtkSynchronizedTemplates3D::Threads[VTK_MAX_THREADS]`[protected]`

| Definition at line 211 of file vtkSynchronizedTemplates3D.h.

char* vtkSynchronizedTemplates3D::InputScalarsSelection`[protected]`

| Definition at line 213 of file vtkSynchronizedTemplates3D.h.

The documentation for this class was generated from the following file:

- Patented/vtkSynchronizedTemplates3D.h